#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>



typedef struct BF
{
   int fd;
   char b[2000];
   int pos; // in bytes
   int last;
   int mode;
} BF;



BF* bitopenread(char* filename)
{
   BF* bf = malloc(sizeof(struct BF));
   bf->fd = open(filename, O_RDONLY);
   bf->last = 8*read(bf->fd, bf->b, 2000);
   bf->pos = 0;
   bf->mode = 0;
   return bf;
}

BF* bitopenwrite(char* filename)
{
   BF* bf = malloc(sizeof(struct BF));
   bf->fd = open(filename, O_WRONLY | O_CREAT | O_TRUNC, 0644);
   bf->pos = 0;
   bf->mode = 1;
   memset(bf->b,0,2000);
   return bf;
}

int bitclose( BF* bf)
{
   if (bf->mode == 1)
	 {
		write(bf->fd, bf->b, (bf->pos+7) >> 3);
	 }   
   close(bf->fd);
   free(bf);
   return 0;
}


int bitwrite(BF* bf, int b)
{
   if (bf->pos == 16000) 
	 {
		write(bf->fd, bf->b, 2000);
		bf->pos = 0;
		memset(bf->b,0,2000);		
	 }

   int i = bf->pos >> 3;
   int j = bf->pos & 7;
   bf->pos++;
   bf->b[i] |= b << (7-j);
   return 1;
}


int bitread(BF* bf)
{
   if (bf->pos == bf->last)
	 {
		bf->last = 8*read(bf->fd, bf->b, 2000);
		bf->pos = 0;
		if (bf->last <= 0) return -1;
	 }
   int i = bf->pos >> 3;
   int j = bf->pos & 7;
   bf->pos++;
   return (bf->b[i] >> (7-j)) & 1;
}

int readint(BF* f, int size)
{
   int i;
   int s = 0;
   for (i = 0; i < size; i++)
	 { 
		int k = bitread(f);
		if (k == -1) return -1;
		s = 2*s + k;
	 }
   return s;
}

int writeint(BF* f, int x, int size)
{
   int i;
   for (i = 0; i < size; i++)
	 {
		bitwrite(f,(x >> (size - i - 1)) & 1);
	 }
   return size;
}
